Index: src/test/java/com/xpn/xwiki/plugin/lucene/IndexUpdaterTest.java
===================================================================
--- src/test/java/com/xpn/xwiki/plugin/lucene/IndexUpdaterTest.java	(revision 0)
+++ src/test/java/com/xpn/xwiki/plugin/lucene/IndexUpdaterTest.java	(revision 0)
@@ -0,0 +1,448 @@
+package com.xpn.xwiki.plugin.lucene;
+
+import junit.framework.Test;
+import junit.framework.TestSuite;
+
+import java.io.File;
+import java.io.IOException;
+
+import java.util.Date;
+import java.util.concurrent.Semaphore;
+
+import org.apache.lucene.store.Directory;
+import org.apache.lucene.store.FSDirectory;
+import org.apache.lucene.index.IndexReader;
+import org.apache.lucene.index.IndexWriter;
+import org.apache.lucene.search.IndexSearcher;
+import org.apache.lucene.search.TopDocs;
+import org.apache.lucene.search.Query;
+import org.apache.lucene.search.TermQuery;
+import org.apache.lucene.index.Term;
+import org.apache.lucene.store.LockObtainFailedException;
+
+import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.XWiki;
+import com.xpn.xwiki.store.XWikiStoreInterface;
+import com.xpn.xwiki.test.AbstractBridgedXWikiComponentTestCase;
+import com.xpn.xwiki.doc.XWikiDocument;
+import com.xpn.xwiki.XWikiConfig;
+import com.xpn.xwiki.XWikiException;
+
+public class IndexUpdaterTest extends AbstractBridgedXWikiComponentTestCase
+{
+    /**
+     * @return the suite of tests being tested
+     */
+    public static Test suite()
+    {
+        return new TestSuite(IndexUpdaterTest.class);
+    }
+
+    public class TestXWiki extends XWiki
+    {
+        public XWikiStoreInterface getStore()
+        {
+            return new TestStore();
+        }
+
+        public XWikiDocument getDocument(String fullname, XWikiContext context)
+        {
+            System.out.println("Fullname: " + fullname);
+            return new LoremIpsum();
+        }
+
+        @Override
+        public XWikiConfig getConfig()
+        {
+            XWikiConfig p = new XWikiConfig();
+            p.setProperty(LucenePlugin.PROP_INDEX_DIR, IndexUpdaterTest.this.indexDir);
+
+            return p;
+        }
+
+        @Override
+        public boolean checkAccess(String action, XWikiDocument doc, XWikiContext context) throws XWikiException
+        {
+            System.out.println("Check access");
+
+            return true;
+        }
+    }
+
+    private class TestIndexRebuilder extends IndexRebuilder
+    {
+        TestIndexRebuilder(IndexUpdater indexUpdater, XWikiContext context, boolean needInitialRebuild)
+        {
+            super(indexUpdater, context, needInitialRebuild);
+        }
+
+        @Override
+        protected void initXWikiContainer(XWikiContext context)
+        {
+        }
+
+        @Override
+        protected void cleanupXWikiContainer(XWikiContext context)
+        {
+        }
+
+        @Override
+        public void run()
+        {
+            System.out.println("Running index rebuilder");
+            super.run();
+            IndexUpdaterTest.this.rebuildDone.release();
+        }
+
+    }
+
+    private class TestIndexUpdater extends IndexUpdater implements Runnable
+    {
+        TestIndexUpdater(Directory directory, int indexingInterval, int maxQueueSize, LucenePlugin plugin,
+            XWikiContext context)
+        {
+            super(directory, indexingInterval, maxQueueSize, plugin, context);
+        }
+
+        @Override
+        protected void initXWikiContainer(XWikiContext context)
+        {
+        }
+
+        @Override
+        protected void cleanupXWikiContainer(XWikiContext context)
+        {
+        }
+        
+        @Override
+        public void run()
+        {
+            System.out.println("Starting new thread: " + Thread.currentThread().getName());
+            if (Thread.currentThread().getName().equals("writerBlocker")) {
+                try {
+                    System.out.println("Holding directory lock for 5s.");
+                    IndexWriter writer = openWriter(true);
+                    Thread.sleep(5000);
+                    System.out.println("Releasing directory lock.");
+                    writer.close();
+                } catch (Exception e) {
+                }
+            } else if (Thread.currentThread().getName().equals("permanentBlocker")) {
+                try {
+                    System.out.println("Obtaining directory lock and waiting.");
+                    IndexWriter writer = openWriter(false);
+                    IndexUpdaterTest.this.writeBlockerAcquiresLock.release();
+                    IndexUpdaterTest.this.writeBlockerWait.acquireUninterruptibly();
+                    System.out.println("Releasing directory lock.");
+                    writer.close();
+                } catch (Exception e) {
+                }
+            } else {
+                super.run();
+            }
+        }
+    }
+
+    private class LoremIpsum extends XWikiDocument
+    {
+        public LoremIpsum()
+        {
+        }
+
+        @Override
+        public String getAuthor()
+        {
+            return "Cicero";
+        }
+
+        @Override
+        public String getCreator()
+        {
+            return "Cicero";
+        }
+
+        @Override
+        public Date getDate()
+        {
+            return new Date(0);
+        }
+
+        @Override
+        public Date getCreationDate()
+        {
+            return new Date(0);
+        }
+
+        @Override
+        public String getName()
+        {
+            return "Ipsum";
+        }
+
+        @Override
+        public String getDisplayTitle(XWikiContext context)
+        {
+            return "Lorem Ipsum";
+        }
+
+        @Override
+        public String getSpace()
+        {
+            return "Lorem";
+        }
+
+        @Override
+        public String getFullName()
+        {
+            return "Lorem.Ipsum";
+        }
+
+        @Override
+        public String getContent()
+        {
+            return "Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.";
+        }
+
+    }
+
+    private final static String indexDir = "target/lucenetest";
+
+    private final Semaphore rebuildDone = new Semaphore(0);
+
+    private final Semaphore writeBlockerWait = new Semaphore(0);
+
+    private final Semaphore writeBlockerAcquiresLock = new Semaphore(0);
+
+    @Override
+    protected void setUp() throws Exception
+    {
+        super.setUp();
+        
+        getContext().setWiki(new TestXWiki());
+        getContext().setDatabase("wiki");
+    }
+    
+    public void testCreateIndex() throws IOException
+    {
+        Directory directory = null;
+        File f = new File(indexDir);
+
+        if (!f.exists()) {
+            f.mkdirs();
+        }
+        directory = FSDirectory.open(f);
+
+        int indexingInterval;
+        indexingInterval = 100;
+        int maxQueueSize;
+        maxQueueSize = 1000;
+
+        LucenePlugin plugin = new LucenePlugin("Monkey", "Monkey", getContext());
+        IndexUpdater indexUpdater = new TestIndexUpdater(directory, indexingInterval, maxQueueSize, plugin, getContext());
+        IndexRebuilder indexRebuilder = new TestIndexRebuilder(indexUpdater, getContext(), true);
+
+        rebuildDone.acquireUninterruptibly();
+
+        assertTrue(IndexReader.indexExists(directory));
+    }
+
+    public void testIndexUpdater() throws Exception
+    {
+        File f = new File(indexDir);
+        Directory directory;
+        if (!f.exists()) {
+            f.mkdirs();
+        }
+        directory = FSDirectory.open(f);
+
+        int indexingInterval;
+        indexingInterval = 100;
+        int maxQueueSize;
+        maxQueueSize = 1000;
+
+        LucenePlugin plugin = new LucenePlugin("Monkey", "Monkey", getContext());
+        IndexUpdater indexUpdater = new TestIndexUpdater(directory, indexingInterval, maxQueueSize, plugin, getContext());
+        IndexRebuilder indexRebuilder = new TestIndexRebuilder(indexUpdater, getContext(), false);
+        Thread writerBlocker = new Thread(indexUpdater, "writerBlocker");
+        writerBlocker.start();
+        plugin.init(indexUpdater, indexRebuilder, getContext());
+
+        indexUpdater.cleanIndex();
+
+        Thread indexUpdaterThread = new Thread(indexUpdater, "Lucene Index Updater");
+        indexUpdaterThread.start();
+
+        indexUpdater.add(new LoremIpsum(), getContext());
+        indexUpdater.add(new LoremIpsum(), getContext());
+
+        try {
+            Thread.sleep(1000);
+            indexUpdater.doExit();
+        } catch (InterruptedException e) {
+        }
+        while (true) {
+            try {
+                indexUpdaterThread.join();
+                break;
+            } catch (InterruptedException e) {
+            }
+        }
+
+        Query q = new TermQuery(new Term(IndexFields.DOCUMENT_ID, "wiki:Lorem.Ipsum.default"));
+        IndexSearcher searcher = new IndexSearcher(directory, true);
+        TopDocs t = searcher.search(q, null, 10);
+
+        System.out.println("Searching for document id, number of hits: " + t.totalHits);
+
+        assertEquals(1, t.totalHits);
+
+        SearchResults results = plugin.getSearchResultsFromIndexes("Ipsum", "target/lucenetest", null, getContext());
+
+        assertEquals(1, results.getTotalHitcount());
+
+        System.out.println("Searching for 'Ipsum', number of hits: " + results.getTotalHitcount());
+        for (SearchResult result : results.getResults()) {
+            System.out.println("id: " + result.getId());
+        }
+    }
+
+    public void testLock() throws IOException
+    {
+        Directory directory;
+        File f = new File(indexDir);
+        int indexingInterval;
+        indexingInterval = 100;
+        int maxQueueSize;
+        maxQueueSize = 1000;
+
+        if (!f.exists()) {
+            f.mkdirs();
+        }
+        directory = FSDirectory.open(f);
+
+        LucenePlugin plugin = new LucenePlugin("Monkey", "Monkey", getContext());
+
+        System.out.println("Creating new updater");
+
+        final IndexUpdater indexUpdater =
+                new TestIndexUpdater(directory, indexingInterval, maxQueueSize, plugin, getContext());
+
+        plugin.init(indexUpdater, getContext());
+
+        Thread permanentBlocker = new Thread(indexUpdater, "permanentBlocker");
+        permanentBlocker.start();
+        writeBlockerAcquiresLock.acquireUninterruptibly();
+
+        assertTrue(IndexWriter.isLocked(indexUpdater.getDirectory()));
+
+        final boolean[] doneCleaningIndex = {false};
+
+        Thread indexCleaner = new Thread(new Runnable()
+        {
+            public void run()
+            {
+                try {
+                    indexUpdater.cleanIndex();
+                    System.out.println("Done cleaning index.");
+                    doneCleaningIndex[0] = true;
+                } catch (IOException e) {
+                    throw new RuntimeException(e);
+                }
+            }
+        }, "indexCleaner");
+
+        indexCleaner.start();
+
+        try {
+            Thread.sleep(5000);
+        } catch (InterruptedException e) {
+        }
+
+        assertFalse(doneCleaningIndex[0]);
+
+        boolean wasActuallyLocked = false;
+
+        try {
+            if (!IndexWriter.isLocked(indexUpdater.getDirectory())) {
+                System.out.println("Not locked!");
+                IndexWriter w =
+                        new IndexWriter(indexUpdater.getDirectory(),
+                            new org.apache.lucene.analysis.standard.StandardAnalyzer());
+            } else {
+                wasActuallyLocked = true;
+            }
+            // assert(IndexWriter.isLocked(indexUpdater.getDirectory()));
+        } catch (LockObtainFailedException e) {
+            /*
+             * Strange, the isLocked method appears to be unreliable.
+             */
+            wasActuallyLocked = true;
+            System.out.println("Failed to obtain lock");
+        } catch (IOException e) {
+            assert (false);
+        }
+
+        assertTrue(wasActuallyLocked);
+
+        writeBlockerWait.release();
+
+        while (true) {
+            try {
+                indexCleaner.join();
+                break;
+            } catch (InterruptedException e) {
+            }
+        }
+
+        assertTrue(doneCleaningIndex[0]);
+
+        assertFalse(IndexWriter.isLocked(indexUpdater.getDirectory()));
+
+        IndexWriter w =
+                new IndexWriter(indexUpdater.getDirectory(), new org.apache.lucene.analysis.standard.StandardAnalyzer());
+        w.close();
+    }
+
+    public void testCleanLock() throws IOException
+    {
+        Directory directory;
+        File f = new File(indexDir);
+        int indexingInterval;
+        indexingInterval = 100;
+        int maxQueueSize;
+        maxQueueSize = 1000;
+
+        if (!f.exists()) {
+            f.mkdirs();
+        }
+        directory = FSDirectory.open(f);
+
+        LucenePlugin plugin = new LucenePlugin("Monkey", "Monkey", getContext());
+
+        System.out.println("Creating new updater");
+
+        final IndexUpdater indexUpdater =
+                new TestIndexUpdater(directory, indexingInterval, maxQueueSize, plugin, getContext());
+
+        plugin.init(indexUpdater, getContext());
+
+        Thread permanentBlocker = new Thread(indexUpdater, "permanentBlocker");
+        permanentBlocker.start();
+        writeBlockerAcquiresLock.acquireUninterruptibly();
+
+        try {
+            IndexWriter.unlock(indexUpdater.getDirectory());
+            // assert(!IndexWriter.isLocked(indexUpdater.getDirectory()));
+            IndexWriter w =
+                    new IndexWriter(indexUpdater.getDirectory(),
+                        new org.apache.lucene.analysis.standard.StandardAnalyzer());
+            w.close();
+
+        } catch (LockObtainFailedException e) {
+            // assert(false);
+            System.out.println("IndexWriter.unlock doesn't work!");
+        }
+
+        writeBlockerWait.release();
+    }
+}
Index: src/test/java/com/xpn/xwiki/plugin/lucene/TestStore.java
===================================================================
--- src/test/java/com/xpn/xwiki/plugin/lucene/TestStore.java	(revision 0)
+++ src/test/java/com/xpn/xwiki/plugin/lucene/TestStore.java	(revision 0)
@@ -0,0 +1,268 @@
+package com.xpn.xwiki.plugin.lucene;
+
+import com.xpn.xwiki.store.XWikiStoreInterface;
+import org.xwiki.query.QueryManager;
+import com.xpn.xwiki.XWikiContext;
+import com.xpn.xwiki.XWikiException;
+import com.xpn.xwiki.doc.XWikiDocument;
+import com.xpn.xwiki.doc.XWikiLink;
+import com.xpn.xwiki.doc.XWikiLock;
+import com.xpn.xwiki.objects.classes.BaseClass;
+
+import java.util.List;
+import java.util.LinkedList;
+
+public class TestStore implements XWikiStoreInterface
+{
+    public void saveXWikiDoc(XWikiDocument doc, XWikiContext context) throws XWikiException
+    {
+    }
+
+    public void saveXWikiDoc(XWikiDocument doc, XWikiContext context, boolean bTransaction) throws XWikiException
+    {
+    }
+
+    public XWikiDocument loadXWikiDoc(XWikiDocument doc, XWikiContext context) throws XWikiException
+    {
+
+        return null;
+    }
+
+    public void deleteXWikiDoc(XWikiDocument doc, XWikiContext context) throws XWikiException
+    {
+    }
+
+    public List<String> getClassList(XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<String>();
+    }
+
+    public List<String> searchDocumentsNames(String wheresql, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<String>();
+    }
+
+    public int countDocuments(String wheresql, XWikiContext context) throws XWikiException
+    {
+        return 0;
+    }
+
+    public List<String> searchDocumentsNames(String wheresql, int nb, int start, XWikiContext context)
+        throws XWikiException
+    {
+        return new LinkedList<String>();
+    }
+
+    public List<String> searchDocumentsNames(String wheresql, int nb, int start, String selectColumns,
+        XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<String>();
+    }
+
+    public List<String> searchDocumentsNames(String parametrizedSqlClause, int nb, int start,
+        List< ? > parameterValues, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<String>();
+    }
+
+    public List<String> searchDocumentsNames(String parametrizedSqlClause, List< ? > parameterValues,
+        XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<String>();
+    }
+
+    public int countDocuments(String parametrizedSqlClause, List< ? > parameterValues, XWikiContext context)
+        throws XWikiException
+    {
+        return 0;
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, boolean distinctbylanguage, XWikiContext context)
+        throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, int nb, int start, XWikiContext context)
+        throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, boolean distinctbylanguage, boolean customMapping,
+        XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, boolean distinctbylanguage, int nb, int start,
+        XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, boolean distinctbylanguage, int nb, int start,
+        List< ? > parameterValues, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, boolean distinctbylanguage, boolean customMapping,
+        int nb, int start, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, boolean distinctbylanguage, boolean customMapping,
+        boolean checkRight, int nb, int start, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, List< ? > parameterValues, XWikiContext context)
+        throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, boolean distinctbylanguage, boolean customMapping,
+        int nb, int start, List< ? > parameterValues, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, int nb, int start, List< ? > parameterValues,
+        XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public List<XWikiDocument> searchDocuments(String wheresql, boolean distinctbylanguage, boolean customMapping,
+        boolean checkRight, int nb, int start, List< ? > parameterValues, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<XWikiDocument>();
+    }
+
+    public XWikiLock loadLock(long docId, XWikiContext context, boolean bTransaction) throws XWikiException
+    {
+        return null;
+    }
+
+    public void saveLock(XWikiLock lock, XWikiContext context, boolean bTransaction) throws XWikiException
+    {
+    }
+
+    public void deleteLock(XWikiLock lock, XWikiContext context, boolean bTransaction) throws XWikiException
+    {
+    }
+
+    public List<XWikiLink> loadLinks(long docId, XWikiContext context, boolean bTransaction) throws XWikiException
+    {
+        return new LinkedList<XWikiLink>();
+    }
+
+    public List<String> loadBacklinks(String fullName, XWikiContext context, boolean bTransaction)
+        throws XWikiException
+    {
+        return new LinkedList<String>();
+    }
+
+    public void saveLinks(XWikiDocument doc, XWikiContext context, boolean bTransaction) throws XWikiException
+    {
+    }
+
+    public void deleteLinks(long docId, XWikiContext context, boolean bTransaction) throws XWikiException
+    {
+    }
+
+    public <T> List<T> search(String sql, int nb, int start, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<T>();
+    }
+
+    public <T> List<T> search(String sql, int nb, int start, List< ? > parameterValues, XWikiContext context)
+        throws XWikiException
+    {
+        return new LinkedList<T>();
+    }
+
+    public <T> List<T> search(String sql, int nb, int start, Object[][] whereParams, XWikiContext context)
+        throws XWikiException
+    {
+        return new LinkedList<T>();
+    }
+
+    public <T> List<T> search(String sql, int nb, int start, Object[][] whereParams, List< ? > parameterValues,
+        XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<T>();
+    }
+
+    public void cleanUp(XWikiContext context)
+    {
+    }
+
+    public boolean isWikiNameAvailable(String wikiName, XWikiContext context) throws XWikiException
+    {
+        return false;
+    }
+
+    public void createWiki(String wikiName, XWikiContext context) throws XWikiException
+    {
+    }
+
+    public void deleteWiki(String wikiName, XWikiContext context) throws XWikiException
+    {
+    }
+
+    public boolean exists(XWikiDocument doc, XWikiContext context) throws XWikiException
+    {
+        if (doc.getFullName().equals("Lorem.Ipsum"))
+            return true;
+        return false;
+    }
+
+    public boolean isCustomMappingValid(BaseClass bclass, String custommapping1, XWikiContext context)
+        throws XWikiException
+    {
+        return false;
+    }
+
+    public boolean injectCustomMapping(BaseClass doc1class, XWikiContext xWikiContext) throws XWikiException
+    {
+        return false;
+    }
+
+    public boolean injectCustomMappings(XWikiDocument doc, XWikiContext context) throws XWikiException
+    {
+        return false;
+    }
+
+    public List<String> getCustomMappingPropertyList(BaseClass bclass)
+    {
+        return new LinkedList<String>();
+    }
+
+    public void injectCustomMappings(XWikiContext context) throws XWikiException
+    {
+    }
+
+    public void injectUpdatedCustomMappings(XWikiContext context) throws XWikiException
+    {
+    }
+
+    public List<String> getTranslationList(XWikiDocument doc, XWikiContext context) throws XWikiException
+    {
+        return new LinkedList<String>();
+    }
+
+    public QueryManager getQueryManager()
+    {
+        return null;
+    }
+}
